package com.tongda.tdtopo.auto;

import com.tongda.tdtopo.config.Neo4jProperties;
import com.tongda.tdtopo.neo4j.Neo4jServer;
import com.tongda.tdtopo.service.TDGraphService;
import org.neo4j.graphdb.GraphDatabaseService;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Configuration
@EnableConfigurationProperties(Neo4jProperties.class)
public class Neo4jAutoConfiguration {

    @Resource
    private Neo4jProperties properties; // 使用配置

    @Bean
    @ConditionalOnMissingBean
    public GraphDatabaseService init() {
        //初始化neo4j
        GraphDatabaseService graphDatabaseService=new Neo4jServer().init(properties.getPath(),properties.getBolt());
        System.out.println("neo4j-server启动成功");
        TDGraphService tdGraphService=new TDGraphService();
        System.out.println(tdGraphService.searchRelationType());
        return graphDatabaseService;

    }

}
